<script setup>
import { date } from 'alga-js'
import { toast } from 'bulma-toast'

const router = useRouter()
const route = useRoute()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const client = useCookie('logship_client')
const clientId = useCookie('logship_client_id')
const organization = useCookie('logship_organization')
const organizationId = useCookie('logship_organization_id')
const warehouse = useCookie('logship_warehouse')
const warehouseId = useCookie('logship_warehouse_id')
const user = useCookie('logship_user')
const userId = useCookie('logship_user_id')

const form = ref({
  id: '',
  uid: '',
  client: client.value?.Name || '',
  clientId: clientId.value || '',
  organization: organization.value?.Name || '',
  organizationId: organizationId.value || '',
  documentNo: '',
  movementDate: date.now('date'),
  approvalAmt: 0,
  chargeAmt: 0,
  freightAmt: 0,
  description: '',
  poReference: '',
  isActive: true,
  isApproved: false,
  isInTransit: false,
  warehouse: warehouse.value?.Name || '',
  warehouseId: warehouseId.value || '',
  warehouseTo: '',
  warehouseToId: '',
  docType: '',
  docTypeId: '',
  shipper: '',
  shipperId: '',
  salesRep: user.value?.Name ?? '',
  salesRepId: user.value?.id ?? userId.value ?? '',
  user: '',
  userId: '',
  partner: '',
  partnerId: '',
  partnerLocation: '',
  partnerLocationId: '',
  freightCostRule: '',
  freightCostRuleId: '',
  priorityRule: '',
  priorityRuleId: '',
  deliveryRule: '',
  deliveryRuleId: '',
  deliveryViaRule: '',
  deliveryViaRuleId: '',
  project: '',
  projectId: '',
  campaign: '',
  campaignId: '',
  docStatus: 'Draft',
  docStatusId: 'DR',
  processed: false,
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/stock-transfers')
  }
}

const save = async (record) => {
  form.value = record

if(form.value.movementDate !== '' && form.value.docTypeId !== '') {
  activeSave.value = true
} else {
  activeSave.value = false
}
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/stock-transfers/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: form.value.organizationId,
      documentNo: form.value.documentNo,
      movementDate: form.value.movementDate,
      approvalAmt: form.value.approvalAmt,
      chargeAmt: form.value.chargeAmt,
      freightAmt: form.value.freightAmt,
      description: form.value.description,
      poReference: form.value.poReference,
      isActive: form.value.isActive,
      isApproved: form.value.isApproved,
      isInTransit: form.value.isInTransit,
      warehouseId: form.value.warehouseId,
      warehouseToId: form.value.warehouseToId,
      docTypeId: form.value.docTypeId,
      shipperId: form.value.shipperId,
      salesRepId: form.value.salesRepId,
      userId: form.value.userId,
      partnerId: form.value.partnerId,
      partnerLocationId: form.value.partnerLocationId,
      freightCostRuleId: form.value.freightCostRuleId,
      priorityRuleId: form.value.priorityRuleId,
      deliveryRuleId: form.value.deliveryRuleId,
      deliveryViaRuleId: form.value.deliveryViaRuleId,
      projectId: form.value.projectId,
      campaignId: form.value.campaignId,
      docStatusId: form.value.docStatusId,
      processed: form.value.processed,
      processing: form.value.processing,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false
    if(saveType === 'preview') {
      router.push('/materials/stock-transfers/' + res.id + '/view')
    } else if(saveType === 'changes' || saveType === 'onlysave') {
      router.push('/materials/stock-transfers/'+res.id+'/edit')
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
    //window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/stock-transfers', text: 'Stock Transfers'},
  { link: '#', text: 'Add Stock Transfer', active: true}
]))

const tab = ref(route.query?.tab || 'inventory')
const tabs = computed(() => ([
  { value: 'inventory', text: 'Inventory Move'},
  { value: 'delivery', text: 'Delivery'},
  { value: 'reference', text: 'Reference'},
  { value: 'status', text: 'Status'}
]))

const openOtherTab = () => {
  if(tab.value === 'inventory') {
    tab.value = 'delivery'
  } else if(tab.value === 'delivery') {
    tab.value = 'reference'
  } else if(tab.value === 'reference') {
    tab.value = 'status'
  }
}
</script>

<template>
  <Head>
    <Title>Add Stock Transfer</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />

    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.movementDate === '' || form.docTypeId === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
        <button v-if="tab !== 'status'" type="button" @click="openOtherTab" class="button">Next</button>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div class="banner">
      <div class="d-flex justify-between mb-3">
        <InsideWindowTab v-model="tab" :tabs="tabs" />
      </div>
      <div>
        <MaterialsStockTransferForm v-model="form" v-model:tab="tab" @save="save"/>
      </div>
      <div class="opacity-0.6 pointerEvents-none">
        <MaterialsStockTransferDetailRecord action="create" :info="form" tab="move_line" />
      </div>
    </div>
  </NuxtLayout>
</template>